// ===============================================================
// udemo.DemoInterface: NATIVE CLASS used to control the demo playback driver!
// This provides for a cleaner method for control than standard console commands.
// note: driver is reponsible for checks including server changing of timedilation and pauser!
// ===============================================================

class DemoInterface expands Object
native;

//variables:
var const PlayerPawn DemoSpec;  //the spectator subclass
var const uDemoDriver DemoDriver; //the demo driver. only valid in cpp

//native functions:   (add interval subdivion ammount?)
native final function SetSpeed (float newSpeed); //playback speed control
native final function JumpTo (float time, float CacheTime); //frame jumping to a specific time (cache time = the read before)
native final function JumpForward (float deltatime); //read deltatime seconds ahead of the demo + tick non-pawn actors by this ammount (0.5 s intervals!)
native final function float GetCurrentTime(); //used for frame jumping caching. this gives the current "jump to" time.
native final function float GetTotalTime(); //time demo lasts (1.0 speed)
native final function PauseDemo(bool bPause); //safely controls demo pausing.
native final function byte IsPaused(); //0=no, 1=user requested, 2=paused in demo (ex. admin hit pause)

//non-native functions:
function GotoFrame (float Time){ //controls jumping
   if (Time > GetTotalTime() || Time < 0)  //invalid
      return;
   if (abs(Time-GetCurrentTime()) < 0.5) //too small interval.. don't jump!
      return;
   if (Time > GetCurrentTime() && Time < GetCurrentTime() + fmax(2*class'DemoSettings'.default.CacheSeconds,5.0))
      JumpForward (Time-GetCurrentTime()); //more efficient and reliable to keep reading
   else //must do complex jumping method...
      JumpTo(time,class'DemoSettings'.default.CacheSeconds);
}


//events:

//in clientdemos, this is the playerpawn the spectator should "link to" for information (HUD, etc.) none in serverdemo!
event LinkToPlayer (PlayerPawn p);

defaultproperties {
}
