// ============================================================
// udemo.UDFeaturesClient: Configure TNSe enhancements + demo recording stuff (recording each map..timestamps, etc.)
// note in udemo 2.0 this is only the recording each map thingy.
// ============================================================

class UDFeaturesClient expands UMenuPageWindow;

var UWindowEditControl Format;
var UWindowLabelControl FormatPreview;
var UWindowCheckBox GenerateInfo;
var UWindowComboControl Activate;

function Created(){
  Super.Created();
  Activate = UWindowComboControl(CreateControl(class'UWindowComboControl', 10, 10, winwidth-18, 1));
  Activate.SetButtons(True);
  Activate.SetText("Auto-Record");
  Activate.Align = TA_Left;
  Activate.SetHelpText("Depending on the option you select, a demo will be recorded during every level with the format specified below.  Note: You must open Unreal Tournament Demo Manager every time you startup UT for this to work.");
  Activate.SetFont(F_Normal);
  Activate.SetEditable(False);
  Activate.editboxwidth=0.7*Activate.winwidth;
  Activate.additem("Never");
  Activate.AddItem("Always");
  Activate.AddItem("SinglePlayer Only");
  Activate.AddItem("MultiPlayer Only");
  Activate.SetSelectedIndex(class'DemoSettings'.default.LevelRecord);
  /*     //FIXME: Add support.
  GenerateInfo=UWindowCheckBox(CreateControl(class'UWindowCheckBox', 10, 30, winwidth-10, 1));
  GenerateInfo.SetText("Auto-Generate Summary");
  GenerateInfo.bchecked=class'DemoSettings'.default.bGenerateInfo;
  GenerateInfo.SetHelpText("If auto-recording is activated, should a (demoname)Info.txt file be written after recording has finished. (This does the same effect as hitting Summary in the Start page)");
  */
  Format = UWindowEditControl(CreateControl(class'UWindowEditControl', 10, 30, winwidth-18, 1));
  Format.editboxwidth=0.7*Format.winwidth;
  Format.SetText("Record Format");
  Format.SetHelpText("Type in the format you want demos to be auto-recorded in.");
  Format.Align = TA_Left;
  Format.SetValue(class'DemoSettings'.default.Format);
  FormatPreview = UWindowLabelControl(CreateControl(class'UWindowLabelControl', 10, 50, winwidth-18, 1));
  FormatPreview.Align = TA_Center;
}
function Notify(UWindowDialogControl C, byte E)
{
  local string Str, Str2;
  local int j;
  Super.Notify(C, E);

  switch(E)
  {
  case DE_Change:    //combo
    switch(C)
    {
    case Activate:
    class'DemoSettings'.default.LevelRecord=Activate.GetSelectedIndex();
    break;
    case GenerateInfo:
 //   class'DemoSettings'.default.bGenerateInfo=GenerateInfo.bChecked;
    break;
    case Format:
      //check bad characters:
      C.NotifyWindow=none;
      Str=Format.GetValue();
      for (j = 0; j<Len(Str); j++){
      //USE reads bad!
        if (InStr("\\/*?<:>\"|", Mid(str, j, 1)) != -1)
          continue;
        else if (InStr(" ", Mid(str, j, 1)) != -1)
          str2 = str2 $ "_";
        else
          str2 = str2 $ Mid(str, j, 1);
      }
      Format.SetValue(str2);
      C.NotifyWindow=self;
      class'DemoSettings'.default.Format=Format.GetValue();
      break;
    }
  }
}
//update preview thing (so seconds stuff):
function Tick(float delta){
  FormatPreview.SetText("Preview: "$class'demosettings'.static.GetDemoName(GetPlayerOwner(),UWindowComboListItem(DemoMainClientWindow(GetParent(class'demomainclientwindow')).UserWindow.Demos.List.Items))$".dem");
}
//write text:
function WriteText(canvas C, string text, out float Y){
  local float W, H;
  TextSize(C, text, W, H);
  ClipText(C, (WinWidth - W)/2, Y, text, false);
  Y+=H;
}
//label info: move this to some pop-up?
function Paint(Canvas C, float X, float Y)
{
  Super.Paint(C,X,Y);
  //Set black:
  c.drawcolor.R=0;
  c.drawcolor.G=0;
  c.drawcolor.B=0;
  Y=FormatPreview.Wintop+FormatPreview.WinHeight-1;
  WriteText(C, "", Y);
  WriteText(C, "The following flags are replaced:", Y);
  WriteText(C, "%L - Current Level Name", Y);
  WriteText(C, "%Y - Year, %M - Month, %D - Day",  Y);
  WriteText(C, "%H - Hour, %O - Min, %S - Sec", Y);
//  WriteText(C, "%H-Hour", Y);
//  WriteText(C, "%O-Minute", Y);
//  WriteText(C, "%S-Seconds", Y);
  WriteText(C, "%V - Server Name", Y);
  WriteText(C, "%N - A number of consecutive names", Y);
  WriteText(C, "%% - The '%' symbol", Y);
}



defaultproperties {
}
