
//#include "UnNet.h"
#include "udemoprivate.h"
//#include "UuDriver.h"

/*-----------------------------------------------------------------------------
	UDemoPlayPendingLevel implementation.
-----------------------------------------------------------------------------*/

//
// Constructor.
//

UDReader::UDReader( UEngine* InEngine, const FURL& InURL,Uudnative * Control )
:	ULevelBase( InEngine, InURL )
{
	guard(UDReader::UDReader);
	Controller=Control;
	// Try to create demo playback driver.
	UClass* DemoDriverClass = StaticLoadClass( UNetDriver::StaticClass(), NULL, TEXT("Engine.DemoRecDriver"), NULL, LOAD_NoFail, NULL );
	DemoRecDriver = ConstructObject<UNetDriver>( DemoDriverClass );
	if( !DemoRecDriver->InitConnect( this, URL, Error ) )
	{
		delete DemoRecDriver;
		DemoRecDriver = NULL;
	}

	unguard;
}

//
// FNetworkNotify interface.
//
ULevel* UDReader::NotifyGetLevel()
{
	guard(UDReader::NotifyGetLevel);
	return NULL;
	unguard;
}
void UDReader::NotifyReceivedText( UNetConnection* Connection, const TCHAR* Text )
{
	guard(UDPlayPendingLevel::NotifyReceivedText);
	//debugf( NAME_DevNet, TEXT("DemoPlayPendingLevel received: %s"), Text );
	if( ParseCommand( &Text, TEXT("USES") ) )
	{
		// Dependency information.
		TCHAR Filename[256];
		int FileSize;
		TCHAR PackageName[NAME_SIZE]=TEXT("");
		FString FName;
		FGuid Guid;
		Parse( Text, TEXT("GUID="), Guid );
		Parse( Text, TEXT("SIZE="), FileSize );
		Parse( Text, TEXT("PKG="), PackageName, ARRAY_COUNT(PackageName) );
		Parse( Text, TEXT("FNAME="), FName);
		UBOOL Installed=appFindPackageFile( PackageName, &Guid, Filename );
		if (FName==TEXT("")||FName.Right(4)==TEXT(".uxx")) //old version or cache file
			FName=(TEXT("%s"),PackageName);	
	//	GLog->Logf(TEXT("Filename '%s' running on appstr returns '%s'"),Filename,appStrstr(Filename,TEXT(".uxx")));
		Controller->eventPackageRequired(FName,FileSize,Installed,Guid,appStrstr(Filename,TEXT(".uxx"))!=NULL);
		//note: filename out returns file path!  if it is in cache, there is no .uxx at end and gives Guid!
	}
	//Kill:
	else if( ParseCommand( &Text, TEXT("WELCOME") ) )
	{
		FURL URL;
	
		// Parse welcome message.
		Parse( Text, TEXT("LEVEL="), URL.Map );
		FString ServerDemo;
		//specialized (FString map,-1,UBOOL serverdemo):
		Controller->eventDemoReadDone(URL.Map,Parse( Text, TEXT("SERVERDEMO"), ServerDemo) );
		guard(Closing);
		DemoRecDriver->LowLevelDestroy();
		DemoRecDriver->Notify=NULL;
		DemoRecDriver=NULL;
		//delete DemoRecDriver;
		Controller->DemoDriver=NULL;
		//GLog->Logf(TEXT("Read level Info from %s and unloaded driver"),URL.Map);
		delete this;
		unguard;
	}
	unguard;
}
void UDReader::Destroy(){
	Controller->DemoDriver=NULL;
	Super::Destroy();
}
/*
// tick is called by the udnative stuff :)
//
void UDReader::Tick( FLOAT DeltaTime )
{
	guard(UDPlayPendingLevel::Tick);
	check(DemoRecDriver);
	check(DemoRecDriver->ServerConnection);

	// Update demo recording driver.
	DemoRecDriver->TickDispatch( DeltaTime );
	DemoRecDriver->TickFlush();

	unguard;
}*/
IMPLEMENT_CLASS(UDReader);


